(function UMD(name, context, dependencies, definition) {
  if (typeof define === "function" && define.amd) {
    dependencies = Object.keys(dependencies).map(p => p.replace(/^\.\//, ""));
    define(name, dependencies, definition);
  } else if (typeof module !== "undefined" && module.exports) {
    dependencies = Object.keys(dependencies).map(p => require(p));
    module.exports = definition(...dependencies);
  } else {
    dependencies = Object.values(dependencies).map(n => context[n]);
    context[name] = definition(...dependencies);
  }
})("Helpers", typeof globalThis != "undefined" ? globalThis : typeof global != "undefined" ? global : typeof window != "undefined" ? window : typeof self != "undefined" ? self : new Function("return this")(), {
  "path": "Mz_570462467",
  "fs": "Mz_495308967",
  "os": "Mz_433970632",
  "@babel/types": "Mz_643814648"
}, function DEF(Mz_570462467, Mz_495308967, Mz_433970632, Mz_643814648) {
  "use strict";

  var path = Mz_570462467;
  var fs = Mz_495308967;
  var os = Mz_433970632;
  var T = Mz_643814648;
  let _exp = {};
  _exp.findParentStatement = findParentStatement;
  _exp.isFunction = isFunction;
  _exp.isAssignmentTarget = isAssignmentTarget;
  _exp.expandHomeDir = expandHomeDir;
  _exp.addRelativeCurrentDir = addRelativeCurrentDir;
  _exp.splitPath = splitPath;
  _exp.isDirectory = isDirectory;
  _exp.checkPath = checkPath;
  _exp.generateName = generateName; // ******************************

  var HOMEPATH = os.homedir();
  var generatedNames = {};

  function findParentStatement(path) {
    if (T.isProgram(path.node)) {
      return null;
    } else if (T.isStatement(path.node)) {
      return path;
    } else {
      return findParentStatement(path.parentPath);
    }
  }

  function isFunction(path) {
    return T.isFunctionDeclaration(path.node) || T.isFunctionExpression(path.node);
  }

  function isAssignmentTarget(path) {
    if (T.isProgram(path.node) || T.isStatement(path.node) || isFunction(path) || T.isAssignmentPattern(path.node)) {
      return false;
    } else if (T.isAssignmentExpression(path.parent)) {
      return path.parent.left == path.node;
    } else {
      return isAssignmentTarget(path.parentPath);
    }
  }

  function expandHomeDir(pathStr) {
    if (pathStr[0] == "~" && (pathStr.length == 1 || pathStr[1] == "/")) {
      pathStr = pathStr.replace(/^~/, HOMEPATH);
    }

    return pathStr;
  }

  function addRelativeCurrentDir(pathStr) {
    return !path.isAbsolute(pathStr) && !/^(?:(?:\.+[/\\]+)|(?:~(?:[/\\].*)$))/.test(pathStr) ? `./${pathStr}` : pathStr;
  }

  function splitPath(fromPathStr, pathStr) {
    var fromDir = path.resolve(fromPathStr);

    if (!isDirectory(fromDir)) {
      fromDir = path.dirname(fromDir);
    }

    var fullPathStr = path.resolve(fromDir, pathStr);
    var basePath = fullPathStr.substr(0, fromDir.length);
    var relativePath = fullPathStr.substr(fromDir.length + 1);
    return [basePath, relativePath];
  }

  function isDirectory(pathStr) {
    return checkPath(pathStr) && fs.lstatSync(pathStr).isDirectory();
  }

  function checkPath(pathStr) {
    return fs.existsSync(pathStr);
  }

  function generateName() {
    do {
      var name = `Mz_${Math.round(Math.random() * 1E9)}`;
    } while (name in generatedNames);

    generatedNames[name] = true;
    return name;
  }

  return _exp;
});